## 新版

## 备注

```
/*** mc 系列之 mjs
 * 对接宜搭公共JavaScript库
 * 公共库地址：https://mc.cloudpure.cn/mjs/mjs.min.js
 ***/

//---------------------- common ----------------------//

// 加载 mjs
export function _mjsLoad(callback = Function.prototype) {
  // const src = "https://mc.cloudpure.cn/mjs/mjs.min.js"
  const src = "http://127.0.0.1:7001/dist/mjs.js"
  const script = document.createElement('script');
  script.type = 'text/javascript';
  script.src = src;
  document.getElementsByTagName('head')[0].appendChild(script);
  script.onload = () => this._mjsInit();;
};

//---------------------- private ----------------------//

// 加载即调用方法请在此处进行调用
export async function _mjsInit() {
  await mjs.init(this, { vconsole: false })
  // 页面环境：0提交(其它)，1查看，2编辑(审批)
  if (!mjs.env) { }

  mjs.request.xhr.doPost("xxxx")
}

//---------------------- event ----------------------//

// 页面节点加载渲染完毕
export function didMount() {
  // 工具库: mjs & 初始化
  this._mjsLoad();
}

// 查询事件
export function onSubmit(values) {
  this.queryAllData(values)
  console.log('onFilterSubmit', values);
}
```

#### 已使用客户

- 新天龙案例

```
/*** mc 系列之 mjs
 * 对接宜搭公共JavaScript库
 * 公共库地址：https://mc.cloudpure.cn/mjs/mjs.min.js
 ***/

//---------------------- common ----------------------//

// 加载 mjs
export function _mjsLoad(callback = Function.prototype) {
  const src = "https://mc.cloudpure.cn/mjs/mjs.min.js"
  // const src = "http://127.0.0.1:7001/dist/mjs.js"
  const script = document.createElement('script');
  script.type = 'text/javascript';
  script.src = src;
  document.getElementsByTagName('head')[0].appendChild(script);
  script.onload = () => this._mjsInit();;
};

//---------------------- private ----------------------//

// 加载即调用方法请在此处进行调用
export async function _mjsInit() {
  await mjs.init(this, { vconsole: false })
  // 页面环境：0提交(其它)，1查看，2编辑(审批)
  if (!mjs.env) { }
  mjs._queryList = mjs.optimize.debounce(param => this.queryList(param), 750)
  console.log(this.$('tablePc_lgp1b94w'))

  this.$("textField_lgp1b94r").set("value", mjs.storage.SS.GET("s_code"))
}


// 查询列表
export async function queryList(values) {
  const date = values.cascadeDateField_lgq1sjrd;
  const rsp = await mjs.request.xhr.doPost("https://mc.cloudpure.cn/api/xintianlong/yd/order-list", {}, {
    order: {
      "formUuid": "FORM-3C866TC1MH19IOBZEXJJ58ZQ36IE3FDACV7FL0",
      "compId_code": "textField_lf7vdf33",
      "condition_code": values.textField_lgp1b94r,
      "compId_date": "dateField_lf80vr20",
      "condition_date": date.start && date.end ? [date.start, date.end] : ""
    },
    supplier: {
      "formUuid": "FORM-AC6660814FW8UIE496KJT4YYKNA022Y1VU7FLC",
      "compId": "textField_lf7v3zj0",
      "condition": values.textField_lgp1b94r
    }
  })
  this.$('tablePc_lgp1b94w').set("data", rsp.data.data)
  mjs.storage.SS.SET("s_code", values.textField_lgp1b94r)
}


//---------------------- event ----------------------//

// 页面节点加载渲染完毕
export function didMount() {
  // 工具库: mjs & 初始化
  this._mjsLoad();
}

// 查询事件
export function onSubmit(values) {
  if (!values.textField_lgp1b94r) {
    this.utils.toast({
      title: '客户代码不能为空！', // 'success', 'warning', 'error', 'notice', 'help', 'loading'
      type: 'error',
      size: 'large',
      duration: 2000, // 毫秒, type 为 loding 时无效
    });
    return
  }
  mjs._queryList(values)
}
```

- 谷元

```

// ocr 识别
export async function ocr(file, dp, reflect) {
  const rsp = await mjs.request.xhr.doPost("https://mc.cloudpure.cn/api/chuoqi/yd/openUrl", {}, {
    "url": file.url
  })
  const ocr = await this.dataSourceMap[dp].load({
    inputs: JSON.stringify({
      image_url: rsp.data.data
    })
  }).catch(err => {
    this.utils.toast({
      title: "图片未识别成功", // err.message, // 'success', 'warning', 'error', 'notice', 'help', 'loading'
      type: 'error',
      size: 'large',
      duration: 2000, // 毫秒, type 为 loding 时无效
    });
  })
  const data = JSON.parse(ocr)
  console.log(data.column18, data)
  this.verify(data)
}

```

- 福氏

```

/*** mc 系列之 mjs
 * 对接宜搭公共JavaScript库
 * 版权请联系：https://www.aliwork.com/o/mjs
 * 公共库地址：https://aliwork.zitoo.com.cn/cdn/mjs.min.js
 ***/

//---------------------- common ----------------------//

function loadAliworkSDK(that) {
  const src = "https://aliwork.zitoo.com.cn/mc/js/mjs.min.js"
  // const src = "http://127.0.0.1:7001/dist/mjs.js"
  const script = document.createElement('script');
  script.type = 'text/javascript';
  script.src = src;
  script.addEventListener('load', () => _mjsLoad(that), false);
  document.head.appendChild(script);
};

//---------------------- private ----------------------//

// 加载即调用方法请在此处进行调用
async function _mjsLoad(that) {
  await mjs.init(that, { vconsole: false })
  // 提交页面自动查询位置：0提交，1查看，2编辑
  if (!mjs.env) { }
}

//---------------------- event ----------------------//

// 页面节点加载渲染完毕
export function didMount() {
  // 工具库: mjs & 初始化
  loadAliworkSDK(this)
}


```

# 前端通过连接器调用发票识别

```
/*** mc 系列之 mjs
 * 对接宜搭公共JavaScript库
 * 版权请联系：https://www.aliwork.com/o/mjs
 * 公共库地址：https://aliwork.zitoo.com.cn/mc/js/mjs.min.js
 ***/

//---------------------- common ----------------------//

// 加载 mjs
export function _mjsLoad(callback = Function.prototype) {
  const src = "https://aliwork.zitoo.com.cn/mc/js/mjs.min.js"
  const script = document.createElement('script');
  script.type = 'text/javascript';
  script.src = src;
  document.getElementsByTagName('head')[0].appendChild(script);
  if (!script.readyState) {
    script.onload = () => this._mjsInit();;
    return;
  }
  // IE
  script.onreadystatechange = () => {
    if (script.readyState == 'loaded' || script.readyState == 'complete') {
      script.onreadystatechange = null;
      this.mounted();
    }
  }
};

//---------------------- private ----------------------//

// 加载即调用方法请在此处进行调用
export async function _mjsInit() {
  await mjs.init(this, { vconsole: false })
  // 页面环境：0提交(其它)，1查看，2编辑(审批)
  if (!mjs.env) { }
}

//---------------------- event ----------------------//

// 页面节点加载渲染完毕
export function didMount() {
  // 工具库: mjs & 初始化
  this._mjsLoad();
}

// ocr识别
export function onSuccess(file, value) {
  this.ocr(file)
}

export async function ocr(file) {
  const rsp = await mjs.request.xhr.doPost("https://aliwork.zitoo.com.cn/api/uc/yd/getMdUrl", {}, {
    "projectId": "100091",
    "imageUrl": file.url
  })
  const ocr = await this.dataSourceMap.ocr.load({
    inputs: JSON.stringify({
      image_url: rsp.data[0]
    })
  }).catch(err => {
    this.utils.toast({
      title: err.message, // 'success', 'warning', 'error', 'notice', 'help', 'loading'
      type: 'error',
      size: 'large',
      duration: 2000, // 毫秒, type 为 loding 时无效
    });
  })
  const data = JSON.parse(ocr)
  const reflect = {
    textField_l5gfoa0p: "column1", // 发票代码
    textField_l5gfoa0q: "column2", // 发票号码
    textField_l61k48y4: "column3", // 开票时间
    textField_l5gfoa0r: "column4", // 校验码
    numberField_l5gfoa0v: "column5", // 开票金额
    numberField_l5gfoa0w: "column7", // 税额
    numberField_l5gfoa0u: "column8", // 不含税金额
    textField_l5gfoa0y: "column9", // 开票公司名称
  }
  console.log(data)
  for (let compId of Object.keys(reflect)) {
    this.$(compId).setValue(data[reflect[compId]])
  }
}
```
