import baseConfig from "./rollup.config.base";
import serve from "rollup-plugin-serve";

import { name } from "../package.json";

export default {
  ...baseConfig,
  output: [
    {
      // file: `api/dist/${name}.js`,
      file: `dist/${name}.js`,
      format: "umd",
      name,
      sourcemap: true,
    },
    {
      file: `dist/${name}.cjs.js`,
      format: "cjs",
      name,
      sourcemap: "inline",
    },
  ],
  plugins: [
    ...baseConfig.plugins,
    serve({
      // frp proxy
      // port: 9001,
      port: 7001,
      contentBase: [""],
    }),
  ],
};
