/// 自定义页面bom展示效果 ///
export default {

  compId: {
    parent: "",
    child: "",
    top: "",  // 第一层
    name: ""
  },

  collectChildren (dto, baseList) {
    const tempList = baseList.filter(d => dto[this.compId.child] == d[this.compId.parent]);
    if (tempList.length > 0) dto.children = tempList;
    for (const child of tempList) {
      this.collectChildren(child, baseList);
    }
  },

  // 查询bom
  async queryHierarchy ({ dpRemote, formUuid, conditions, compId_tree }) {
    const rsp = await mjs.request.dp.queryForm({ formUuid, conditions, dpRemote }, { queryAll: true })
    const dataList = rsp.data.map(item => {
      return {
        ...item.formData,
        label: item.formData[this.compId.name],
        key: item.formData[this.compId.child],
        formInstId: item.formInstId
      }
    });
    const topList = dataList.filter(d => this.compId.top == d[this.compId.parent]);
    for (const dto of topList) {
      this.collectChildren(dto, dataList);
    }
    if (compId_tree) mjs.$this.$(compId_tree).set("dataSource", topList)
    return dataList;
  }

}
