const com = {};

// 页面环境: 0提交(其它)，1查看，2编辑(审批)
com.checkEnv = function () {
  const instanceData = mjs.$this.utils.getFormInstanceData();
  const { flowData = {} } = instanceData;
  const { editMode, viewMode } = flowData;
  if (editMode) return 2; // 审批页面为2, 编辑状态
  if (viewMode) return 1;
  return 0;
};

// 冗余Toast提示方法
com.showMessage = function (title, type = "success", size = "medium", duration = "750") {
  if (!title) return;
  mjs.$this.utils.toast({ type, title, size, duration });
};

// type: 'success', 'warning', 'error', 'notice', 'help', 'loading'
com.showErrorMessage = function (title) {
  this.showMessage(title, "error");
}

// size: large, medium
com.showSuccessMessage = function (title) {
  this.showMessage(title);
}

// 冗余显示全屏loading: 全局对象
let G_DIALOG;
com.showLoading = function (title = "拼命加载中...") {
  if (G_DIALOG) return; // 避免多次闪屏
  G_DIALOG = mjs.$this.utils.toast({ type: "loading", title, closeable: false, footer: false, messageProps: { type: "loading", }, });
};

// 冗余隐藏全屏loading: 全局对象
com.hideLoading = function () {
  G_DIALOG && G_DIALOG();
  G_DIALOG = null;
};

// 弹出确认框
com.showConfirm = function (title, content, type = "confirm") {
  if (!title && !content) {
    throw new Error(`${type} => The title and content are empty.`);
  }
  return new Promise((resolve, reject) => {
    mjs.$this.utils.dialog({
      type, title, content, /* 如需换行可传入 HTML/JSX 来实现 */
      onOk: () => resolve(),
      onCancel: () => reject("用户取消了"),
    });
  });
};

/// toast access
com.toastAccess2 = function (isShow, title) {
  if (isShow) {
    this.utils.toast({
      title: title, // 'success', 'warning', 'error', 'notice', 'help', 'loading'
      type: 'error',
      size: 'large',
      duration: 2000, // 毫秒, type 为 loding 时无效
    });
    throw new Error(title);
  }
}

// 提交校验toast
// TODO: 阻断 throw
com.toastAccess = function (isShow, title, resolve, reject) {
  if (isShow) {
    mjs.$this.utils.toast({
      title: title, // 'success', 'warning', 'error', 'notice', 'help', 'loading'
      type: 'error',
      size: 'large',
      duration: 2000, // 毫秒, type 为 loding 时无效
    });
    reject && reject(title)
    return false;
  }
  resolve && resolve()
  return true;
}

/**
 * TODO:
// 弹出框填写校验
export function _validateDialog(callback, ...compIds) {
  for (const compId of compIds) {
    this.$(compId).validate
  }

}
 */

/**
 * ppExt: 提交校验 [存在请求若报错无需catch]
 * 1. 返回Promise时，不能在Promise外直接return，会提示undefined
 * 2. 失败需要返回reject，否则不会重置按钮loading状态，无法重新发起提交
 */

// 提交错误toast
com.toastError = function (title, resolve, reject) {
  return this.toastAccess(!!title, title, resolve, reject)
}

// 提交弱校验【后置: 置于所有判断的最后, 避免命中若校验直接提交了】
com.dialogTips = function (title, message, resolve, reject) {
  if (title || message) {
    mjs.$this.utils.dialog({
      method: 'alert', // 'alert', 'confirm', 'show'
      title: title,
      content: message, // 如需换行可传入 HTML/JSX 来实现
      onOk: () => {
        resolve && resolve()
      },
      onCancel: () => {
        reject && reject()
      }
    });
    return false
  }
  return true
}

// 获取当前地址的表单实例ID
com.getFormInstIdByUrl = function () {
  if (mjs.$this) {
    // 智障的设计：流程从管理页面进入是 formInstId ，流程提交完成是 procInsId
    const query = mjs.$this.utils.router.getQuery();
    return query.procInsId || query.formInstId;
  }
  const url = window.location.href;
  if (url.includes("procInsId=")) {
    return url.split("procInsId=")[1].split("&")[0];
  }
  return url.split("formInstId=")[1].split("&")[0];
}

export default com;
