const dom = {};

// 异常打印和评论按钮: 兼容BUG, 平台设置不生效
dom.removeMobInvalid = function (that) {
  const doms = document.querySelectorAll(".flow-operation-button");
  doms.forEach((ele) => {
    if (["评论", "打印"].includes(ele.textContent)) ele.remove();
  });
};

// 设置iframe组件, 并且加载;链接
dom.iframeLoadFullScreen = function (that, { compId, link, bottom = 44 }) {
  document.getElementById(`frame_${compId}`).style.height =
    window.screen.height - bottom + "px";
  that.$(compId).set("src", link);
};

// 去除tab间距样式调整
dom.removeLayoutSpace = function (that) {
  const doms = document.querySelectorAll(".next-tabs-content");
  doms.forEach((elem) => elem.remove());
};

import ding from "../vendor/dingApi";
import bus from "./bus";

// 审批页面: button事件的3种绑定方式以及触发逻辑：https://www.cnblogs.com/ooo0/p/7742214.html
dom.registerFlowEvent = function (that) {
  if (mjs.env != 2) return;
  setTimeout(() => {
    const approveEvent = (title) => {
      // 回调审批事件
      if (bus.DOM_CALLBACK_APPROVE) {
        bus.DOM_CALLBACK_APPROVE(that, title);
        return;
      }
    }
    // PC端
    const doms = document.querySelectorAll(".flow-button"); // 使用getElementsByClassName拿不到dom实体
    if (doms.length) {
      // 读取弹出框按钮: 延迟体验
      const listenerDialog = function (title) {
        setTimeout(() => {
          // 多个使用不需要添加空格
          document.querySelectorAll(".next-btn.next-small").forEach((ele) => {
            // 取消刷新页面: dom二次会失效
            if ("取消" == ele.innerText) {
              ele.onclick = function () {
                window.location.reload()
              };
            }
            if ("确认" == ele.innerText) {
              ele.onclick = function () {
                approveEvent(title);
              };
            }
          });
        }, 200);
      };
      doms.forEach((ele) => {
        // 目前退回为加签逻辑 ==> 退回页面环境为编辑态值2
        if (["同意", "拒绝", "退回", "转交", "提交"].includes(ele.innerText)) {
          ele.onclick = function () {
            listenerDialog(ele.innerText);
          };
        }
      });
      return;
    }
    // 移动端
    const listenerDialog = function (title) {
      // 读取弹出框按钮: 延迟体验
      setTimeout(() => {
        let doms = document.querySelectorAll(".t-button"); // 其它
        if (!doms.length) doms = document.querySelectorAll(".mt-button"); // 退回
        // 取消刷新页面: dom二次会失效
        document.querySelectorAll(".flow-layer-header-left").forEach(ele => {
          ele.onclick = function () {
            window.location.reload()
          };
        })
        doms.forEach((ele) => {
          if (["提交", "确认退回"].includes(ele.innerText)) {
            ele.onclick = function () {
              approveEvent(title);
            };
          }
        });
      }, 200);
    };
    document.querySelectorAll(".icon-box").forEach((ele) => {
      // 目前退回为加签逻辑 ==> 退回页面环境为编辑态值2
      if (["退回", "转交", "提交"].includes(ele.innerText)) {
        ele.onclick = function () {
          listenerDialog(ele.innerText);
        };
      }
    });
    document.querySelectorAll(".mt-button").forEach((ele) => {
      // 目前退回为加签逻辑 ==> 退回页面环境为编辑态值2
      if (["同意", "拒绝"].includes(ele.innerText)) {
        ele.onclick = function () {
          listenerDialog(ele.innerText);
        };
      }
    });
  }, 200);
};

// 提交页面: button事件的3种绑定方式以及触发逻辑：https://www.cnblogs.com/ooo0/p/7742214.html
dom.closeCurrentTabForSubmit = function (that) {
  // 退回再提交走审批事件, 目前退回为加签逻辑 ==> 退回页面环境为编辑态值2
  if (mjs.env) return;
  function closeTab () {
    // 执行顺序: onclick > addEventListener > beforeSubmit
    // 特别说明：在提交情况下，页面存在beforeSubmit，相关的逻辑在beforeSubmit下要手动调用，因为这里是直接触发若是有判断情况下决定权交给beforeSubmit处理
    if (that.beforeSubmit) return;
    // 异步不会等待
    dom.closeTabCompatibilityBeforeSubmit(that);
  }
  // PC端 & 移动端
  let doms = document.querySelectorAll(".deep-form-submit");
  if (!doms.length) return
  doms[0].addEventListener("click", closeTab, false);
};

// 兼容 beforeSubmit 情况下, 异步且在按钮事件之后的问题 执行顺序: onclick > addEventListener > beforeSubmit
dom.closeTabCompatibilityBeforeSubmit = function (that) {
  bus.DOM_CALLBACK_SUBMIT(that);
  // 关闭页面: 延迟体验
  ding.closeNavigationForDomEvent(that);
};

// 隐藏tab空白
dom.removeTabLayoutContainer = function () {
  const elemP = document.querySelectorAll(".next-tabs-content")[0];
  if (elemP) elemP.remove();
}

// 自定义页面全屏: pc
dom.removeSpaceForCustomPage = function () {
  const page = document.getElementsByClassName("vc-rootcontent");
  if (page.length) {
    page[0].style.margin = "0px";
    page[0].className = "";
  }
}

// 隐藏默认打印模板
dom.removePrinterForDefault = function () {
  if (!mjs.env) return;
  // pc - 全屏
  let doms = document.querySelectorAll(".next-icon-printer");
  if (doms.length) {
    doms[0].onclick = function () {
      setTimeout(() => {
        document.querySelectorAll(".next-menu-item").forEach(elem => {
          if (elem.innerText == "默认模板") {
            elem.remove()
          }
        })
      }, 100);
    };
  }
  // pc - 侧边栏
  doms = document.querySelectorAll(".next-yida-button-iconOnly");
  if (doms.length) {
    doms[2].onclick = function () {
      setTimeout(() => {
        document.querySelectorAll(".next-menu-item").forEach(elem => {
          if (elem.innerText == "打印") {
            elem.onclick = function () {
              setTimeout(() => {
                document.querySelectorAll(".next-menu-item").forEach(elem => {
                  if (elem.innerText == "默认模板") {
                    elem.remove()
                  }
                })
              }, 100);
            }
          }
        })
      }, 100)
    }
  }
  // mobile
  setTimeout(() => {
    doms = document.querySelectorAll(".icon-box.dayin");
    if (doms.length) {
      doms[0].onclick = function () {
        setTimeout(() => {
          document.querySelectorAll(".mt-actionsheet-option").forEach(elem => {
            if (elem.innerText == "默认模板") {
              elem.remove()
            }
          })
        }, 100);
      };
    }
  }, 400);

}

// 隐藏撤销按钮 [ppExt: 11.27 宜搭更新后, 直接remove导致dom报错, 应该是有对dom操作, 更新兼容]
dom.removeTerminationButton = function () {
  if (!mjs.env) return;
  // pc
  setTimeout(() => {
    const doms = document.querySelectorAll(".deep-button-group-item");
    if (doms.length) {
      doms[doms.length - 1].style.display = "none";
      return
    }
  }, 400)
  // mobile
  setTimeout(() => {
    const doms = document.querySelectorAll(".icon-box.chexiao");
    if (doms.length) {
      doms[doms.length - 1].style.display = "none";
    }
  }, 400);
}

export default dom;
