// 数据逻辑组装
import {
  _resetDetailData,
  __redundancy_value__,
} from "../../deploy/aliwork-v3";

const logic = {}

// 明细更新明细数据
logic.updateCompDetailFromDetail = function (that,
  { resList, props, compId_detail_src, compId_detail_cur } = {},
  { funcFilter, isForm = true, isUpdate = true } = {}) {
  _resetDetailData(that, compId_detail_cur, props); // 重置明细数据
  if (!resList.length) return;
  const form = resList[0][isForm ? "formData" : "data"];
  if (!form) return;
  let srcDetails = form[compId_detail_src];
  if (funcFilter) {
    // 过滤方法条件：detail => detail["compId"] == "条件"
    srcDetails = srcDetails.filter((detail) => funcFilter(detail));
  }
  const details = srcDetails.map((detail) => {
    return props.reduce((row, prop) => {
      row[prop.cur] = __redundancy_value__(detail, prop.src, prop.def);
      return row;
    }, {});
  });
  /** 连续更新会异常: 需要调用调用forceUpdate才会生效, 若后续即将有更新, 这里置为false, 匹配明细: queryArrayFormOrProcessAndUpdate */
  if (isUpdate) that.$(compId_detail_cur).setValue(destails);
  return details;
}

// 明细加载主表数据
logic.updateCompDetailFromMain = async function (
  that,
  { resList, props, compId_detail_cur } = {},
  { funcFilter, isForm = true } = {}
) {
  _resetDetailData(that, compId_detail_cur, props); // 重置明细数据
  if (!resList.length) return;
  let srcList = resList;
  if (funcFilter) {
    // 过滤方法条件：main => main["compId"] == "条件"
    srcList = srcList.filter((item) =>
      funcFilter(item[isForm ? "formData" : "data"])
    );
  }
  const details = srcList.map((item) => {
    const detail = item[isForm ? "formData" : "data"];
    return props.reduce((row, prop) => {
      let value = __redundancy_value__(detail, prop.src, prop.def);
      // 兼容主表填充明细获取实例ID
      if (prop.def == "formInstId") value = item[prop.def];
      row[prop.cur] = value;
      return row;
    }, {});
  });
  that.$(compId_detail_cur).setValue(details);
  return details;
}

export default logic;
