import request from "../service/request";

// -------------------- 服务商crm -------------------- //


// 跑批地址
function __batch_url__ (url) {
  return `http://139.196.10.121:38805/fws${url}`;
}

// 跑批服务
async function __batch_server__ (url) {
  mjs._showLoading();
  const res = await request.post(__batch_url__(url));
  mjs._hideLoading();
  mjs._showMessage("强开 ➜ 抢单, 跑批完成");
  return res;
}
/** @exports 跑批: 强开 ➜ 抢单 */
export async function _batchAbandonToGrab () {
  return __batch_server__("/data/openToGrabbing");
}

/** @exports 跑批: 抢单 ➜ 公海 */
export async function _batchGrabToPublic () {
  return __batch_server__("/data/openToGrabbing");
}

///////////////////////////////////////////////////// 私有方法 /////////////////////////////////////////////////////

// 效验用户的库容是否符合可操作空间
async function __verify_user_capacity__ (userId) {
  const usr = JSON.stringify([userId || loginUser.userId]);
  // 查询当前登录人库容
  mjs._showLoading();
  const res = await mjs.aliworkTheDynamicSubsidiary("/form/select", {
    ...window.zParams,
    formId: "FORM-YSA66KC1PZALF9TC3IQYNC6VW9LU3JGACCXHKOE",
    conditionList: [{ fieldName: "employeeField_ki45o38a", value: usr }],
  });
  if (!res.list.length) {
    mjs._hideLoading();
    mjs._showMessage("您没有库容信息，请联系管理员维护！", "error");
    return {};
  }
  const capacity = res.list[0].formData["numberField_khxccepl"];
  // 查询当前登录人客户数量
  const resp = await mjs.aliworkTheDynamicSubsidiary("/form/select", {
    ...window.zParams,
    formId: "FORM-2O5667C141SKMDAVWESOGVMV8NUU1X32PSLHKNF3",
    conditionList: [
      { fieldName: "employeeField_khlsp71r", value: usr },
      { fieldName: "selectField_khxcivp1", value: "新客户" },
    ],
  });
  mjs._hideLoading();
  const customCount = resp.list.length;
  const isOperation = capacity >= customCount;
  if (!isOperation)
    mjs._showMessage("您的库容已满, 请释放客户再捞取", "error");
  return { isOperation, capacity, customCount };
}

//////////////////////////////////////////////// 服务商 CRM 业务场景 ////////////////////////////////////////////////

/** @exports 私海客户:今日强开逻辑\放弃按钮操作 */
export async function _copyInsertToAbandonAndUpdatePrivate (ctx) {
  await mjs._showConfirm("操作提示", "将执行客户强开操作");
  const formInstId = mjs._valueInstanceIdHref();
  // 今日强开客户数据：以复制方式新增
  const res = await mjs._insertFromInstance(
    ctx,
    { formUuid: "FORM-JFYJPKDVQIILRIE00TBVO56FRUJW2HGMW27IKQ3", formInstId },
    (params) => {
      // 新增强开数据需要变更字段
      params["selectField_khxcivp8"] = "今日强开"; // 客户类型
      params["selectField_kjv4jdnj"] = "自主放弃"; // 开放类型
      params["employeeField_kicwjyay"] = JSON.stringify([loginUser.userId]); // 私海释放人
      params["employeeField_khlsp71r"] = JSON.stringify([]); // 客户负责人
      params["textField_kiij9tqe"] = formInstId; // 记录实例ID
      return params;
    }
  );
  if (!res.success) return;
  // 更新内容对照表：客户类型变更为今日强开，客户归属人置空, 记录最新操作时间
  const updateList = [
    { fieldName: "selectField_khxcivp8", value: "今日强开" },
    { fieldName: "dateField_khxcivp2", value: new Date().getTime() },
    { fieldName: "employeeField_khlsp71r", value: JSON.stringify([]) },
  ];
  mjs._updateFormList({ updateList, formInstId }, { isReload: false });
}

/** @exports 今日抢单\公海捞取:确保页面组件ID一致性 */
export async function _updatePrivateAndDeleteCurrentRedirect (
  ctx,
  { msg = "将执行客户操作" }
) {
  await mjs._showConfirm("操作提示", msg);
  if (
    ctx.store.get("employeeField_kicwjyay").getVal()[0].key == loginUser.userId
  ) {
    mjs._showMessage("客户释放人不能抢单", "error");
    return;
  }
  const { isOperation } = await __verify_user_capacity__();
  if (!isOperation) return;
  // 更新内容对照表: 客户类型变更为私海客户，客户归属人设置登录人
  const formInstId = ctx.store.get("textField_kiij9tqe").getVal();
  const updateList = [
    { fieldName: "selectField_khxcivp8", value: "私海客户" },
    {
      fieldName: "employeeField_khlsp71r",
      value: JSON.stringify([loginUser.userId]),
    },
  ];
  mjs._updateFormList({ updateList, formInstId });
  // 不传入formInstI, 会执行删除当前记录;
  const redirect = mjs._formatInstanceLink({
    formInstId,
    formUuid: "FORM-2O5667C141SKMDAVWESOGVMV8NUU1X32PSLHKNF3",
  });
  mjs._deleteFormInstance({}, (isSuccess) => {
    if (isSuccess) window.location.href = redirect;
  });
}
