
/*** mjs 之 福氏钉钉SAP接口对接
 * 对接宜搭公共JavaScript库
 * 版权请联系：https://www.aliwork.com/o/mjs
 * 项目库地址: https://ding.practek.cn:38080/api/mjs/mjs.min.js
 ***/

import { KEY_NO_LOADING, KEY_SHOW_MESSAGE } from "../service/request";

export default {

  // 公共配置
  init () {
    mjs.conf.api = "https://ding.practek.cn:38080/api/fushi";
    return this; // this 指向当前项目本身
  },

  // 定制配置
  SYNC_SUC_ALL: "全部成功",

  // 获取申请人部门层级
  async getDepartmentCascade (userId, compId) {
    const rsp = await mjs.request.xhr.doPost("/user/department", { userId }, null, {
      [KEY_NO_LOADING]: true
    });
    mjs.$this.$(compId).setValue(rsp.data.map(item => item.name).join(" / "))
  },

  // mjs加载完成: 加载推送按钮
  purchaseLoad () {
    const status = mjs.$this.$("textField_l2uot27h").getValue() == "同意" && mjs.$this.$('textareaField_l2lgyawc').getValue() != this.SYNC_SUC_ALL;
    mjs.$this.$('pageSection_l2uoi3fr').setBehavior(status ? "NORMAL" : "HIDDEN")
  },

  // mjs加载完成: 加载推送按钮
  paymentLoad () {
    const status = mjs.$this.$('radioField_l2og167t').getValue() == "是" && mjs.$this.$("textField_l2uot27h").getValue() == "同意"
      && mjs.$this.$('textareaField_l2lgyawc').getValue() != this.SYNC_SUC_ALL;
    mjs.$this.$('pageSection_l2uoi3fr').setBehavior(status ? "NORMAL" : "HIDDEN")
  },

  // 推送采购订单
  async sapPurchase (compId) {
    this.doSap("/sap/purchase", compId)
  },

  // 推送付款申请
  sapPayment (compId) {
    this.doSap("/sap/payment", compId)
  },

  // 推送SAP
  async doSap (path, compId) {
    const button = mjs.$this.$(compId);
    button.set("loading", true)
    const rsp = await mjs.request.xhr.doPost(path, { processInstanceId: mjs.com.getFormInstIdByUrl() }, null, {
      [KEY_SHOW_MESSAGE]: true
    })
    if (rsp.message == this.SYNC_SUC_ALL) {
      button.set("behavior", "HIDDEN")
      return
    }
    setTimeout(() => {
      location.reload();
    }, 750);
  }
};
