import request from "./request";
import { u8cGetAllCorp, u8cPushPayment } from "../service/network";

// 报销 v2.0

// /** @exports 健高导出-v2 */
// export { aliworkInitParams } from "./service/network";
// export { _checkSubmitEnv, _formatDetailToJsonString } from "./deploy/aliwork";

// -------------------- 健高 -------------------- //

/**
 * @function 使用是接口
 * 1.aliworkInitParams
 * 2._checkSubmitEnv
 * 3._formatDetailToJsonStringw
 */

// 健高宜搭\U8服务地址
function _aliworkHisJianGaoUrl (uri) {
  return "https://yd.jiangaoerke-info.com/" + uri;
}

/**
 * @exports 健高:获取钉钉指定人员部门列表
 * @param userId
 **/
export function ddingAddressBookForDepart (userId) {
  return request.post(_aliworkHisJianGaoUrl("dingUser/getDIByUId"), {
    userId,
  });
}

/** @exports 获取公司信息 */
export async function _u8cGetCompanyList () {
  const res = await u8cGetAllCorp();
  return res.data.list.map((item) => {
    return {
      text: item.unitname,
      value: item.unitcode,
    };
  });
}

// 临时接口: 替代注册服务测试
export async function _u8cPushProofOfPayment (orderType, { params, details }) {
  await u8cPushPayment({
    orderType,
    ...params,
    djlxbm: "D5",
    traderype: 2,
    pj_jsfs: 104,
    hbbm: "",
    subList: details,
  });
}
