import request from "../service/request";
import { KEY_M_CONTENT_TYPE } from "../service/request";

// -------------------- 意迪尔 -------------------- //

// 意迪尔服务地址
function _aliworkYdrUrl (uri) {
  return "https://aliwork.zitoo.com.cn/yde" + uri;
}

/**
 * @exports 查询U8销售列表
 **/
export async function queryOrderList ({ prop, ctx, compId }) {
  const res = await request.postFormDataAppend(
    _aliworkYdrUrl("/order/batchGet"),
    {
      page_index: 1,
      rows_per_page: 100,
    },
    {
      [KEY_M_CONTENT_TYPE]: true,
    }
  );
  if (!prop) return res.data.list;
  const options = res.data.list.map((item) => {
    const value = item[prop];
    return {
      text: value,
      value,
    };
  });
  ctx.store.get(compId).set("options", options);
}

/**
 * @exports 查询U8销售明细列表
 **/
export async function queryOrderDetailList (
  { conditions, props, ctx, compId_detail_cur } = {},
  { funcFilter } = {}
) {
  if (!conditions.length) return;
  const ids = conditions.join(",");
  const res = await request.postFormDataAppend(
    _aliworkYdrUrl("/order/getDetail"),
    {
      ids,
    },
    {
      [KEY_M_CONTENT_TYPE]: true,
    }
  );
  const resList = res.data.list;
  return _updateCompDetailFromDetail(
    { ctx, resList, compId_detail_cur, props },
    { funcFilter }
  );
}

//////////////////////////////////////////////// 数据处理 ////////////////////////////////////////////////

import { _resetDetailData, _updateCompDetail } from "./aliwork";

// list数据更新明细组件
export function _updateCompDetailFromDetail (
  { ctx, resList, props, compId_detail_cur } = {},
  { funcFilter } = {}
) {
  _resetDetailData(ctx, compId_detail_cur, props); // 重置明细数据
  if (!resList.length) return;
  if (funcFilter) {
    // 过滤方法条件：detail => detail["compId"] == "条件"
    resList = resList.filter((detail) => funcFilter(detail));
  }
  const details = resList.map((detail) => {
    return props.reduce((row, prop) => {
      const value = detail[prop.src] || prop.def;
      row[prop.cur] = { fieldData: { value, text: value } }; // 明细空白解决办法
      return row;
    }, {});
  });
  return _updateCompDetail(ctx, compId_detail_cur, details);
}
