
import request from "./request";

//////////////////////////////////////////// 宜搭服务 ////////////////////////////////////////////

/**
 * @exports 公共:查询单据数据
 * @param url: 单据 /form/select ; 流程 /process/select
 * @param conditionList: 原关联表单的字段, 如 [{"fieldName":"selectField_k9tw8gaq","value":"天城水榭一期"}] - 只能查询当前formId下的表单字段
 **/
export function aliworkTheDynamicSubsidiary (
  url,
  { userId, appType, formId, conditionList, pageIndex = 1, pageSize = 10 }
) {
  // 宜搭限制上限为100
  if (pageSize > 100) pageSize = 100;
  const params = {
    pageIndex,
    pageSize,
    userId,
    appType,
    formId,
  };
  if (conditionList) params.conditionList = conditionList;
  return request.postData(_aliworkZitooUrl(url), params);
}

/**
 * @exports 公共:修改组件数据,明细是全量覆盖
 * @param url: 单据 /form/update ; 流程 /process/update
 * @param updateList: 更新表单内的字段, 如 [{"fieldName":"compId","value":"xxxx"}] - 通过实例Id进行更新
 **/
export function aliworkTheDynamicUpdate (
  url,
  { userId, appType, formInstId, updateList }
) {
  const params = {
    userId,
    appType,
    formInstId,
  };
  if (updateList) params.conditionList = updateList;
  return request.postData(_aliworkZitooUrl(url), params);
}

/**
 * @exports 公共:新增实例,表单\流程
 * @param url: 单据 /form/insert ; 流程 /process/insert
 * @param params: 数据和语雀文档一直, systemToken 不传, 后端通过 appType 匹配
 **/
export function aliworkTheDynamicInsert (url, params) {
  return request.postData(_aliworkZitooUrl(url), params);
}

/**
 * @exports 公共:删除实例,表单\流程
 * @param url: 单据 /form/delete ; 流程 /process/delete
 * @param params: userId, appType, formInstId\processInstanceId
 *
 **/
export function aliworkTheDynamicDelete (url, params) {
  return request.postData(_aliworkZitooUrl(url), params);
}

/**
 * @exports 公共:实例详情,表单\流程(流程支持批量)
 * @param url: 单据 /form/getFormDataById ; 流程 process/getInstancesByIds
 * @param params: userId, appType, formInstId\processInstanceIds
 *
 **/
export function aliworkTheDynamicDetail (url, params) {
  return request.postData(_aliworkZitooUrl(url), params);
}

/** @exports 公共:附件转免登访问地址 */
export function aliworkConvertOpenUrl (params) {
  return request.postData(_aliworkConnecterUrl("getMdUrl"), params);
}
