/**
 * @exports 返回变量型跨域
 * @returns 如获取ip: https://pv.sohu.com/cityjson?ie=utf-8, 返回值：var returnCitySN = {"cip": "124.79.25.204", "cid": "310101", "cname": "上海市黄浦区"};
 **/
export function crossDomainByScript(src, prop) {
  if (!src) Promise.reject("地址不能为空");
  return new Promise((resolve) => {
    const script = document.createElement("script");
    script.setAttribute("type", "text/javascript");
    script.setAttribute("src", src);
    document.body.appendChild(script);
    script.onload = function () {
      resolve(window[prop]);
    };
  });
}
