export default {

  // 四舍五入位数
  round (number, precision) {
    return Math.round(+number + 'e' + precision) / Math.pow(10, precision);
    //same as:
    //return Number(Math.round(+number + 'e' + precision) + 'e-' + precision);
  },

  // 获取最大值
  max (list, prop) {
    const arr = list.map(item => item[prop])
    // apply, 修改this指向: Math.max.apply(null, arr); 或 Math.max.apply(Math, arr);
    return Math.max(arr)
  },

  // 获取最小值
  min (list, prop) {
    const arr = list.map(item => item[prop])
    return Math.min(arr)
  },

  // 四舍五入保留两位小数 (不够位数, 则用0替补)
  keepTwoDecimalFull (num) {
    let result = parseFloat(num);
    if (isNaN(result)) {
      return "0.00";
    }
    result = Math.round(num * 100) / 100;
    let s_x = result.toString();
    let pos_decimal = s_x.indexOf(".");
    // 当整数时, pos_decimal=-1 自动补0
    if (pos_decimal < 0) {
      pos_decimal = s_x.length;
      s_x += ".";
    }
    // 当数字的长度 < 小数点索引 +2时, 补0
    while (s_x.length <= pos_decimal + 2) {
      s_x += "0"
    }
    return s_x;
  },

  // 求两整数最大公约数
  gye (a, b) {//辗转相除法
    return a % b == 0 ? b : gye(b, a % b)
  },

  // 求出最小公倍数
  gbe (m, n) {
    return sun = m * n / gye(m, n) //最小公倍数等于=两数的乘积/最大公约数
  },
}
