/**
 * @export 获取随机数
 */
export function getRandomNumber (count = 1, max = 999, min = 1) {
  return new Promise((resolve) => {
    setTimeout(() => {
      const arr = [];
      for (let i = 0; i < count; i++) {
        let num = (
          Math.floor(Math.random() * (max - min + 1)) + min
        ).toString();
        num = (Array(max.toString().length).join("0") + num).slice(
          -max.toString().length
        );
        arr.push(num);
      }
      resolve(arr);
    }, 750);
  });
}

/**
 * @export 表单关联有数据延迟：数字金额大写转换(可以处理整数,小数,负数)
 */
export function rmbFormat (n) {
  var fraction = ["角", "分"];
  var digit = ["零", "壹", "贰", "叁", "肆", "伍", "陆", "柒", "捌", "玖"];
  var unit = [
    ["元", "万", "亿"],
    ["", "拾", "佰", "仟"],
  ];
  var head = n < 0 ? "欠" : "";
  n = Math.abs(n);
  var s = "";
  for (var i = 0; i < fraction.length; i++) {
    s += (
      digit[Math.floor(n * 10 * Math.pow(10, i)) % 10] + fraction[i]
    ).replace(/零./, "");
  }
  s = s || "整";
  n = Math.floor(n);
  for (var i = 0; i < unit[0].length && n > 0; i++) {
    var p = "";
    for (var j = 0; j < unit[1].length && n > 0; j++) {
      p = digit[n % 10] + unit[1][j] + p;
      n = Math.floor(n / 10);
    }
    s = p.replace(/(零.)*零$/, "").replace(/^$/, "零") + unit[0][i] + s;
  }
  return (
    head +
    s
      .replace(/(零.)*零元/, "元")
      .replace(/(零.)+/g, "零")
      .replace(/^整$/, "零元整")
  );
}

/**
 * @export 日期格式化
 */
function formatDate (time = new Date().getTime(), format = 'YYYY-MM-DD HH:mm:ss') {
  var date = new Date(time);

  var year = date.getFullYear(),
    month = date.getMonth() + 1,//月份是从0开始的
    day = date.getDate(),
    hour = date.getHours(),
    min = date.getMinutes(),
    sec = date.getSeconds();
  var preArr = Array.apply(null, Array(10)).map(function (elem, index) {
    return '0' + index;
  });
  var newTime = format.replace(/YYYY/g, year)
    .replace(/MM/g, preArr[month] || month)
    .replace(/DD/g, preArr[day] || day)
    .replace(/HH/g, preArr[hour] || hour)
    .replace(/mm/g, preArr[min] || min)
    .replace(/ss/g, preArr[sec] || sec);

  return newTime;
}
