

export function loadAMap (key, loadUI = true, version = "2.0") {
  return new Promise((resolve, reject) => {
    if (!key) {
      throw new Error("key不能为空");
    }
    if (window.AMap) {
      return resolve(window.AMap);
    }
    const src = `https://webapi.amap.com/maps?v=${version}&key=${key}&callback=onAMapLoad`;
    const script = document.createElement("script");
    script.onerror = () => {
      return reject();
    };
    script.src = src;
    document.head.appendChild(script);
    window.onAMapLoad = async () => {
      if (loadUI) {
        await loadAMapUI();
      }
      resolve(window.AMap);
    }
  })
}

export function loadAMapUI () {
  return new Promise((resolve, reject) => {
    if (window.AMapUI) {
      return resolve(window.AMapUI);
    }
    const script = document.createElement("script");
    script.src = "https://webapi.amap.com/ui/1.1/main.js";
    document.head.appendChild(script);
    script.onload = () => {
      return resolve(window.AMapUI);
    };
    script.onerror = () => {
      return reject();
    };
  });
}
