import Pinyin from "./lib/pinyin";

/** @export 获取中文首字母 */
export function getCaptureUpper(txt) {
  return Pinyin.GetJP(txt);
}

/** @export 宜搭生成明细的Id:部门首字母+年月日+递增编号 */
export function getDetailCompId(depart, details, compId, space = "") {
  if (!depart || !details) return;
  const date = new Date();
  const month = date.getMonth() + 1; // 日期格式月是从0开始的
  const unique =
    getCaptureUpper(depart) +
    space +
    date.getFullYear() +
    (month < 10 ? "0" + month : month);
  return details.map((item, index) => {
    item[compId] = {
      fieldData: {
        value: unique + (Array(3).join("0") + (index + 1)).slice(-3),
      },
    };
    return item;
  });
}

/** @export 宜搭生成明细的Id:部门首字母+GZ+年月(健高固定资产) */
export function getDetailCompIdWithGZ(depart, details, compId) {
  return getDetailCompId(depart, details, compId, "GZ");
}
