import { format, parse } from "fecha";

export function dateFmt () {
  return format;
}

export function dateParse () {
  return parse;
}

/** 计算时间差: day */
export function calcCeilDay (timestampStart, timestampEnd) {
  let start = new Date(timestampStart);
  let end = new Date(timestampEnd);
  start = format(start, "YYYY-MM-DD");
  end = format(end, "YYYY-MM-DD");
  start = parse(`${start} 00:00:00`, "YY-MM-DD HH:mm:ss");
  end = parse(`${end} 23:59:59`, "YY-MM-DD HH:mm:ss");
  const day = (end.getTime() - start.getTime()) / 1000 / 60 / 60 / 24;
  return Math.ceil(day);
}

/** @exports 获取指定年月的最后一天 */
export function getLastDayFromYM (year, month) {
  if (!year) year = new Date().getFullYear();
  if (!month) month = new Date().getMonth() + 1;
  // 使用new Date(year,month,0)的方式,可以获取该月的最后一天
  return new Date(year, month, 0).getDate();
}

/** @exports 获取自指定日期或者今天是周几 */
export function getWeekFromDate (date = new Date(), fmt = "天一二三四五六") {
  // 使用new Date(year,month,0)的方式,可以获取该月的最后一天
  return fmt.charAt(date.getDay());
}

/** @exports 获取当前日期本周的周日-周六,返回-Date */
export function getCurrentWeekFromDate (date = new Date()) {
  let start = new Date(date.getTime() - date.getDay() * 86400000);
  let end = new Date(date.getTime() + (6 - date.getDay()) * 86400000);
  start = format(start, "YYYY-MM-DD");
  start = parse(`${start} 00:00:00`, "YY-MM-DD HH:mm:ss");
  end = format(end, "YYYY-MM-DD");
  end = parse(`${end} 23:59:59`, "YY-MM-DD HH:mm:ss");
  return [start, end];
}

export default {
  dateFmt, dateParse
}



/**
 *  今天最早于最晚
 const sToday = mjs.date.dateParse()(mjs.date.dateFmt()(new Date(), "YYYY-MM-DD") + " 00:00:00", "YYYY-MM-DD HH:mm:ss").getTime();
    const eToday = mjs.date.dateParse()(mjs.date.dateFmt()(new Date(), "YYYY-MM-DD") + " 23:59:59", "YYYY-MM-DD HH:mm:ss").getTime(); */


/**
 *  延迟赋值
 * const sToday = mjs.date.dateParse()(mjs.date.dateFmt()(new Date(), "YYYY-MM-DD") + " 00:00:00", "YYYY-MM-DD HH:mm:ss").getTime();
const eToday = mjs.date.dateParse()(mjs.date.dateFmt()(new Date(), "YYYY-MM-DD") + " 23:59:59", "YYYY-MM-DD HH:mm:ss").getTime();
setTimeout(() => {
  this.$('dateField_likcqjcr').setValue(sToday)
  this.$('dateField_likcqjcs').setValue(eToday)
}, 400) */
