import diff from "diff";

export function diffTextAreaToRichText(
  that,
  { compId_pre, compId_cur, compId_rich, editMode = true }
) {
  if (editMode) {
    that.$(compId_cur).setBehavior("HIDDEN");
    that.$(compId_rich).setBehavior("NORMAL");
  }
  const preText = that.$(compId_pre).getValue().split("\n");
  const curText = that.$(compId_cur).getValue().split("\n");
  const arrDiff = diff.diffArrays(preText, curText, {
    newlineIsToken: true,
    ignoreWhitespace: true,
  });
  const arr = arrDiff.map((item) => {
    const fmtStyle = () => {
      const arrT = item.value.map((sub) => {
        if (item.added) {
          return `<div style="color: #c10015;">${sub}</div>`;
        }
        if (item.removed) {
          return `<div style="text-decoration: line-through;">${sub}</div>`;
        }
        return `<div style="color: #333333;">${sub}</div>`;
      });
      return arrT.join("");
    };
    return fmtStyle();
  });
  const content = arr.join("");
  const html = `
  <div style="font-size: 12px; color: #66666; line-height: 28px;">对比差异</div>
  <div style="text-align: justify; font-size: 14px; line-height: 28px; font-weight: 400; ">${content}</div>`;
  if (compId_rich) that.$(compId_rich).setValue(html);
  return arrDiff;
}
